
var fs = require('fs');
var path = require('path');
var mkdirp = require('mkdirp');

module.exports = function(obj) {
  return new Promise(function(resolve,reject) {
    var builddir = obj.config.builddir;
    var todo = 0;

    var writeFile = function(article) {
      var filename = path.join(builddir,article.file,"index.html");
      mkdirp(path.dirname(filename), function() {
        fs.writeFile(filename, article.content, function(err) {
          if(err) reject(err);
          todo--;
          if(todo <= 0) resolve(obj);
        });
      });
    }
    obj.pages.forEach(function(o) { writeFile(o); })
    obj.redirects.forEach(function(o) { writeFile(o); })
    obj.tags.forEach(function(o) { writeFile(o); })
    if(todo <= 0) resolve(obj);
  })
}
